config/routes.rb
Moocchat::Application.routes.draw do
  mount JasmineRails::Engine => '/specs' if defined?(JasmineRails)

  resources :conditions
  resources :activity_schemas
  resources :questions
  resources :templates

  root :to => 'tasks#static', :as => 'root'

  get '/group_formation_times/:activity_schema_id/:condition_id' =>
    'waiting_rooms#group_formation_times'

  get '/seconds_to_next_group_formation/:activity_schema_id/' =>
    'waiting_rooms#seconds_to_next_group_formation'

  get '/get_current_timestamp_utc/' =>
    'waiting_rooms#get_current_timestamp_utc'

  match '/auth/:provider/callback', :to => 'sessions#try_login'
  get '/auth/failure', :to => 'sessions#login_failed'
  post '/logout', :to => 'sessions#destroy'

  post '/tasks/:learner_name/:activity_schema_id/:condition_id' => 'tasks#create', :as => 'task_create'
  post '/tasks' => 'tasks#create' # regular form posting
  get '/tasks/turk/:condition_id' => 'tasks#create_turk' # entry point for Turk workers

  post '/tasks/:id/force_continue', :to => 'tasks#force_continue', :as => 'task_force_continue'

  post '/tasks/:id/disconnect', :to => 'tasks#disconnect', :as => 'task_disconnect'

  post '/tasks/:id/heartbeat', :to => 'tasks#heartbeat', :as => 'task_heartbeat'

  get '/tasks/error', :to => 'tasks#error', :as => 'task_error'

  get '/tasks/:id', :to => 'tasks#welcome', :as => 'task_welcome'

  post '/tasks/:id/join_group', :to => 'tasks#join_group', :as => 'task_join_group'

  get '/tasks/:id/complete', :to => 'tasks#complete', :as => 'task_complete'

  get '/tasks/:id/page', :to => 'tasks#page', :as => 'task_page'

  post '/tasks/:id/collect_response', :to => 'tasks#collect_response', :as => 'task_collect_response'

  post '/tasks/:id/next_page', :to => 'tasks#next_page', :as => 'task_next_page'

  post '/tasks/:id/log', :to => 'tasks#log', :as => 'task_log_event'

  get "users/record_consent"
  get "users/check_consent"

  get '/reports/chatlog' => 'reports#chatlog'
  post '/reports/chatlog/show' => 'reports#chatlog_show'
  get '/reports/sessions' => 'reports#sessions'
  post '/reports/sessions/show' => 'reports#sessions_show'

end

app/models/condition.rb
class Condition < ActiveRecord::Base
  include HasManyInline
  has_many :tasks
  has_many :event_logs
  has_many_inline :prologue_pages, :class_name => :template
  has_many_inline :body_pages, :class_name => :template
  has_many_inline :epilogue_pages, :class_name => :template
  belongs_to :primary_activity_schema, :class_name => "ActivitySchema"
  belongs_to :time_filler, :class_name => "ActivitySchema"

  # The maximum allowable group size; experiments cannot specify chat groups
  # containing more than this number of learners.
  MAX_ALLOWABLE_GROUP_SIZE = 20

  # Human-friendly name for the condition or experiment; must be unique
  attr_accessible :name, :prologue_pages, :body_pages, :epilogue_pages,:preferred_group_size, :minimum_group_size, :body_repeat_count, :time_filler, :primary_activity_schema
  validates_presence_of :name, :primary_activity_schema
  validates_uniqueness_of :name
  validates_numericality_of(:preferred_group_size,
    :greater_than_or_equal_to => 1,
    :less_than_or_equal_to => MAX_ALLOWABLE_GROUP_SIZE)
  validates_numericality_of(:minimum_group_size,
    :greater_than_or_equal_to => 1,
    :less_than_or_equal_to => ->(condition) { condition.preferred_group_size },
    :message => 'must be between 1 and preferred group size')
  validates_numericality_of :body_repeat_count, :greater_than_or_equal_to => 1
  
  validate :at_least_one_body_page?

  def at_least_one_body_page?
    errors.add(:body_pages, 'must contain at least 1 page') if body_pages.empty?
  end

  def time_filler_questions
    return time_filler.questions
  end
end

app/controllers/conditions_controller.rb
class ConditionsController < ApplicationController
  include ConditionHelper

  before_filter do
    # A canned activity schema, guaranteed to be available because it's in seeds.rb
    @default_activity ||= ActivitySchema.first
    # Canned learners, guaranteed to be available because of seeds.rb
    @test_learners ||= Learner.where :for_testing => true
  end
  
  # GET /conditions
  def index
    @conditions = Condition.all
  end

  # GET /conditions/1
  def show
    @condition = Condition.find(params[:id])
  end

  # GET /conditions/new
  def new
    @condition = Condition.new
  end

  # GET /conditions/1/edit
  def edit
    @condition = Condition.find(params[:id])
  end

  # POST /conditions
  def create
    params[:condition][:primary_activity_schema] = (params[:condition][:primary_activity_schema] == "")? nil : ActivitySchema.find(params[:condition][:primary_activity_schema].to_i)
    params[:condition][:time_filler] = (params[:condition][:time_filler] == "")? nil : ActivitySchema.find(params[:condition][:time_filler].to_i)

    #to handle the collection_select to object array
    @prologue=params[:condition][:prologue_pages]
    @body=params[:condition][:body_pages]
    @epilogue=params[:condition][:epilogue_pages]
    params[:condition][:prologue_pages] = array_for(@prologue) unless @prologue == nil
    params[:condition][:body_pages] = array_for(@body) unless  @body == nil
    params[:condition][:epilogue_pages] = array_for(@epilogue) unless @epilogue == nil 
    @condition = Condition.new(params[:condition])
    if @condition.save
      redirect_to @condition, notice: 'Condition was successfully created.'
    else
      render action: "new"
    end
  end

  # PUT /conditions/1
  def update
    @condition = Condition.find(params[:id])

    params[:condition][:primary_activity_schema] = (params[:condition][:primary_activity_schema] == "")? nil : ActivitySchema.find(params[:condition][:primary_activity_schema].to_i)
    params[:condition][:time_filler] = (params[:condition][:time_filler] == "")? nil : ActivitySchema.find(params[:condition][:time_filler].to_i)

    #to handle the collection_select to object array
    @prologue=params[:condition][:prologue_pages]
    @body=params[:condition][:body_pages]
    @epilogue=params[:condition][:epilogue_pages]
    params[:condition][:prologue_pages] = array_for(@prologue) unless @prologue == nil
    params[:condition][:body_pages] = array_for(@body) unless  @body == nil
    params[:condition][:epilogue_pages] = array_for(@epilogue) unless @epilogue == nil 
    
    if @condition.update_attributes(params[:condition])
      puts(@condition)
      redirect_to @condition, notice: 'Condition was successfully updated.'
    else
      render action: "edit"
    end
  end

  # DELETE /conditions/1
  def destroy
    @condition = Condition.find(params[:id])
    @condition.destroy
    redirect_to conditions_url 
  end
end

app/helpers/condition_helper.rb
module ConditionHelper
	def array_for(things)
		things.to_a.map { |id| Template.find_by_id(id) }.compact
	end
end

app/views/conditions/_form.html.erb
<div class = "notice">
  <%if @condition.errors.any? %>
   <% @condition.errors.full_messages.each do |message| %>
      <%= message %>
    <% end%>
  <% end%>
</div>
<%= form_for @condition, :html => { :class => 'form-horizontal' } do |f| %>
  <div class="control-group">
    <%= f.label :name, :class => 'control-label' %>
    <div class="controls">
      <%= f.text_field :name, :class => 'text_field' %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :prologue_pages, :class => 'control-label' %>
    <% index = 0 %>
      <% 10.times do %>
        <div class="controls">
              <%= collection_select( :prologue_pages, :id, ::Template.all, :id, :name,
                {prompt: 'None'}, 
                {class: "form-control", id: "prologue_Pages#{index}", name: "condition[prologue_pages][]"}  ) %> 
        </div>
        <% index+=1 %>
      <%end %>
  </div>
  <div class="control-group">
    <%= f.label :body_repeat_count, :class => 'control-label' %>
    <div class="controls">
      <%= f.number_field :body_repeat_count, :class => 'number_field' %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :body_pages, :class => 'control-label' %>
    <% index = 0 %>
      <% 10.times do %>
        <div class="controls">
            <%= collection_select( :body_pages, :id, ::Template.all, :id, :name,
          {prompt: 'None'}, 
          {class: "form-control", id: "body_Pages#{index}", name: "condition[body_pages][]"}  ) %> 
        </div>
        <% index+=1 %>
      <% end %>
  </div>
  <div class="control-group">
    <%= f.label :epilogue_pages, :class => 'control-label' %>
    <% index = 0 %>
      <% 10.times do %> 
        <div class="controls">
             <%= collection_select( :epilogue_pages, :id, ::Template.all, :id, :name,
          {prompt: 'None'}, 
          {class: "form-control", id: "epilogue_Pages#{index}", name: "condition[epilogue_pages][]"}  ) %>       
      </div>
      <% index+=1 %>
      <% end %>
  </div>
  <br>
  <div class="control-group">
    <%= f.label :preferred_group_size, :class => 'control-label'  %>
    <div class="controls">
    <%= f.select :preferred_group_size, (1..Condition::MAX_ALLOWABLE_GROUP_SIZE) %>
    </div>
  </div>
  <div class="control-group">
    <%= f.label :minimum_group_size, :class => 'control-label'  %>
    <div class="controls">
    <%= f.select :minimum_group_size, (1..Condition::MAX_ALLOWABLE_GROUP_SIZE) %>
    </div>
  </div>
    <!-- TBD: create UI for specifying prologue/epilogue/body pages -->

  <div class="control-group">
    <%= f.label :primary_activity_schema, :class => 'control-label'  %>
    <div class="controls">
      <%= collection_select( :primary_activity_schema, :id, ActivitySchema.all, :id, :name,
        {prompt: 'Please Select from the following choices'}, 
        {class: "form-control", name: "condition[primary_activity_schema]" }) %>
    </div>
  </div>

  <div class="control-group">
    <%= f.label :time_filler, :class => 'control-label'  %>
    <div class="controls">
      <%= collection_select( :time_filler, :id, ActivitySchema.all, :id, :name,
        {prompt: 'Please Select from the following choices'}, 
        {class: "form-control", name: "condition[time_filler]" }) %>
    </div>
  </div>

  <div class="form-actions">
    <%= f.submit nil, :class => 'btn btn-primary' %>
    <%= link_to t('.cancel', :default => t("helpers.links.cancel")),
                conditions_path, :class => 'btn' %> 
  </div>
<% end %>

app/views/conditions/edit.html.erb
<%- model_class = Condition -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.edit', 'Edit %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/conditions/index.html.haml
.page-header
  %h1 Conditions

%p= link_to 'New', new_condition_path, :class => 'btn btn-mini'

%table.table.table-striped
  %thead
    %tr
      %th Name
      %th Prologue
      %th Body
      %th Epilogue
      %th Last updated
      %th Primary acitivity schema
      %th Time filler
      %th Actions

  %tbody
    - @conditions.each do |condition|
      %tr
        %td= condition.name
        - %w(prologue_pages body_pages epilogue_pages).each do |pages|
          %td
            - condition.send(pages).each do |page|
              = link_to page.name, edit_template_path(page)
              %br
        %td= condition.updated_at.to_formatted_s
        %td= condition.primary_activity_schema.name
        - time_filler_name = (condition.time_filler == nil)? "nil" : condition.time_filler.name
        %td= time_filler_name
        %td
          = link_to 'Edit', edit_condition_path(condition), :class => 'btn btn-mini'
          - if condition.minimum_group_size == 1
            = button_to 'Test Drive', task_create_path(@test_learners.first.name, @default_activity, condition), :class => 'btn btn-mini'
          = link_to 'Delete', condition_path(condition), :method => :delete, :data => { :confirm => 'Are you sure?' }, :class => 'btn btn-mini btn-danger'

app/views/conditions/new.html.erb
<%- model_class = Condition -%>
<div class="page-header">
  <h1><%=t '.title', :default => [:'helpers.titles.new', 'New %{model}'], :model => model_class.model_name.human.titleize %></h1>
</div>
<%= render :partial => 'form' %>

app/views/conditions/show.html.erb
<%- model_class = Condition -%>
<div class="page-header">
  <h1><%=t '.title', :default => model_class.model_name.human.titleize %></h1>
</div>

<dl class="dl-horizontal">
  <dt><strong><%= model_class.human_attribute_name(:name) %>:</strong></dt>
  <dd><%= @condition.name %></dd>
  <dt><strong><%= model_class.human_attribute_name(:prologue_pages) %>:</strong></dt>
  <dd><% if @condition.prologue_pages.any? %>
          <% @condition.prologue_pages.each do |elm| %>
            <%= link_to elm.name, template_path(elm) %>
          <%end%>
        <%end%>
  </dd>
  <dt><strong><%= model_class.human_attribute_name(:body_pages) %>:</strong></dt>
  <dd><% if @condition.body_pages.any? %>
          <% @condition.body_pages.each do |elm| %>
            <%= link_to elm.name, template_path(elm) %>
          <%end%>
      <%end%>
  </dd>
  <dt><strong><%= model_class.human_attribute_name(:epilogue_pages) %>:</strong></dt>
  <dd><% if @condition.epilogue_pages.any? %>
          <% @condition.epilogue_pages.each do |elm| %>
            <%= link_to elm.name, template_path(elm) %>
          <%end%>
      <%end%>
  </dd>
  <dt><strong><%= model_class.human_attribute_name(:preferred_group_size) %>:</strong></dt>
  <dd><%= @condition.preferred_group_size %></dd>
  <dt><strong><%= model_class.human_attribute_name(:minimum_group_size) %>:</strong></dt>
  <dd><%= @condition.minimum_group_size %></dd>
  <dt><strong><%= model_class.human_attribute_name(:primary_activity_schema) %>:</strong></dt>
  <dd><%= @condition.primary_activity_schema.name %></dd>
  <dt><strong><%= model_class.human_attribute_name(:time_filler) %>:</strong></dt>
  <dd><%= @condition.time_filler.name %></dd>
</dl>
  

<div class="form-actions">
  <%= link_to t('.back', :default => t("helpers.links.back")),
              conditions_path, :class => 'btn'  %>
  <%= link_to t('.edit', :default => t("helpers.links.edit")),
              edit_condition_path(@condition), :class => 'btn' %>
  <%= link_to t('.destroy', :default => t("helpers.links.destroy")),
              condition_path(@condition),
              :method => 'delete',
              :data => { :confirm => t('.confirm', :default => t("helpers.links.confirm", :default => 'Are you sure?')) },
              :class => 'btn btn-danger' %>
</div>